﻿using SushiBarContracts.BindingModel;
using SushiBarContracts.ViewModels;
using SushiBarDataModels;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Runtime.Serialization;

namespace SushiBarDatabaseImplement.Models
{
    [DataContract]
    public class MessageInfo : IMessageInfoModel
    {
        public int Id => throw new NotImplementedException();    

        [DataMember]
        [Key]
        public string MessageId { get; set; } = string.Empty;

        [DataMember]
        public int? ClientId { get; set; }

        [DataMember]
        [Required]
        public string SenderName { get; set; } = string.Empty;

        [DataMember]
        [Required]
        public DateTime DateDelivery { get; set; } = DateTime.Now;

        [DataMember]
        [Required]
        public string Subject { get; set; } = string.Empty;

        [DataMember]
        [Required]
        public string Body { get; set; } = string.Empty;

        public virtual Client? Client { get; set; }

        public static MessageInfo? Create(MessageInfoBindingModel model)
        {
            if(model == null) return null;
            return new MessageInfo
            {
                MessageId = model.MessageId,
                ClientId = model.ClientId,
                SenderName = model.SenderName,
                DateDelivery = model.DateDelivery,
                Subject = model.Subject,
                Body = model.Body,
            };
        }

        public MessageInfoViewModel GetViewModel => new()
        {
            MessageId = MessageId,
            ClientId = ClientId,
            SenderName = SenderName,
            DateDelivery = DateDelivery,
            Subject = Subject,
            Body = Body,
        };
    }
}
