﻿using SushiBarContracts.BindingModel;
using SushiBarContracts.ViewModels;
using SushiBarDataModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Linq;

namespace SushiBarFileImplement.Models
{
    [DataContract]
    public class Implementer : IImplementerModel
    {
        [DataMember]
        public int Id { get; private set; }

        [DataMember]
        public string ImplementerFIO { get; private set; } = string.Empty;

        [DataMember]
        public string Password { get; private set; } = string.Empty;

        [DataMember]
        public int WorkExperience { get; private set; }

        [DataMember]
        public int Qualification { get; private set; }
        public static Implementer? Create(ImplementerBindingModel model)
        {
            if (model == null)
            {
                return null;
            }
            return new Implementer()
            {
                Id = model.Id,
                ImplementerFIO = model.ImplementerFIO,
                WorkExperience = model.WorkExperience,
                Password = model.Password,
                Qualification = model.Qualification,
            };
        }
        public static Implementer? Create(XElement element)
        {
            if (element == null)
            {
                return null;
            }
            return new Implementer()
            {
                Id = Convert.ToInt32(element.Attribute("Id")!.Value),
                ImplementerFIO = element.Element("ImplementerFIO")!.Value,
                WorkExperience = Convert.ToInt32(element.Element("WorkExperience")!.Value),
                Password = element.Element("Password")!.Value,
                Qualification = Convert.ToInt32(element.Element("Qualification")!.Value),
            };
        }
        public void Update(ImplementerBindingModel model)
        {
            if (model == null)
            {
                return;
            }
            ImplementerFIO = model.ImplementerFIO;
            Qualification = model.Qualification;
            Password = model.Password;
            WorkExperience = model.WorkExperience;
        }
        public ImplementerViewModel GetViewModel => new()
        {
            Id = Id,
            ImplementerFIO = ImplementerFIO,
            WorkExperience = WorkExperience,
            Password = Password,
            Qualification = Qualification
        };
        public XElement GetXElement =>
            new("Implementer",
            new XAttribute("Id", Id),
            new XElement("ImplementerFIO", ImplementerFIO),
            new XElement("WorkExperience", WorkExperience),
            new XElement("Password", Password),
            new XElement("Qualification", Qualification)
            );
    }
}